## net.sf.saxon.sort
Class CalendarValueComparer

    java.lang.Object
      net.sf.saxon.sort.CalendarValueComparer

All Implemented Interfaces:
  Serializable, AtomicComparer

    public class CalendarValueComparer

extends Object
implements AtomicComparer

A comparer specifically for comparing two date, time, or dateTime values

See Also:
  Serialized Form

Constructor Summary
`CalendarValueComparer(Configuration config)`

Method Summary
`int` `compareAtomicValues(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects according to the rules for their data type.
`boolean` `comparesEqual(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects for equality according to the rules for their data type.
`ComparisonKey` `getComparisonKey(AtomicValue a)` Get a comparison key for an object.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CalendarValueComparer

    public CalendarValueComparer(Configuration config)

Method Detail

### compareAtomicValues

    public int compareAtomicValues(AtomicValue a,
                                   AtomicValue b)

  Compare two AtomicValue objects according to the rules for their data type. UntypedAtomic values are compared as if they were strings; if different semantics are wanted, the conversion must be done by the caller.

  Specified by:
    `compareAtomicValues` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the java.util.Comparable interface.
    `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
  Returns:
    <0 if a<b, 0 if a=b, >0 if a>b
  Throws:
    `ClassCastException` - if the objects are not comparable

### comparesEqual

    public boolean comparesEqual(AtomicValue a,
                                 AtomicValue b)

  Compare two AtomicValue objects for equality according to the rules for their data type. UntypedAtomic values are compared by converting to the type of the other operand.

  Specified by:
    `comparesEqual` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the equals() method.
    `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
  Returns:
    true if the values are equal, false if not
  Throws:
    `ClassCastException` - if the objects are not comparable

### getComparisonKey

    public ComparisonKey getComparisonKey(AtomicValue a)

  Get a comparison key for an object. This must satisfy the rule that if two objects are equal, then their comparison keys are equal, and vice versa. There is no requirement that the comparison keys should reflect the ordering of the underlying objects.

  Specified by:
    `getComparisonKey` in interface `AtomicComparer`

Copyright (C) Michael H. Kay. All rights reserved.